Debian Bug report logs - #680234
sane-backends: FTBFS[kfreebsd]:

version graph

Package: src:sane-backends; Maintainer for src:sane-backends is Mark Buda <hermit@acm.org>;

Reported by: debian-bsd@lists.debian.org

Date: Wed, 4 Jul 2012 14:39:05 UTC

Severity: serious

Tags: patch, sid, wheezy

Found in version sane-backends/1.0.22-7.2

Fixed in version sane-backends/1.0.22-7.3

Done: Michael Gilbert <mgilbert@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-bsd@lists.debian.org, Julien BLACHE <jblache@debian.org>:
Bug#680234; Package src:sane-backends. (Wed, 04 Jul 2012 14:39:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to debian-bsd@lists.debian.org:
New Bug report received and forwarded. Copy sent to debian-bsd@lists.debian.org, Julien BLACHE <jblache@debian.org>. (Wed, 04 Jul 2012 14:39:11 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Christoph Egger <christoph@debian.org>
To: submit@bugs.debian.org
Subject: sane-backends: FTBFS[kfreebsd]:
Date: Wed, 04 Jul 2012 16:37:24 +0200
Package: src:sane-backends
Version: 1.0.22-7.2
Severity: serious
Tags: sid wheezy
User: debian-bsd@lists.debian.org
Usertags: kfreebsd
X-Debbugs-Cc: debian-bsd@lists.debian.org
Justification: fails to build from source (but built successfully in the past)

Hi!

Your package failed to build on the kfreebsd-* buildds:

/bin/bash ../libtool --silent  --tag=CC   --mode=compile x86_64-kfreebsd-gnu-gcc -DHAVE_CONFIG_H -I. -I../include/sane -I/usr/local/include -I. -I. -I../include -I../include -DLIBDIR="/usr/lib/x86_64-kfreebsd-gnu/sane" -DDEB_DLL_LIBDIR="\"/usr/lib/x86_64-kfreebsd-gnu/sane:/usr/lib/sane\"" -DBACKEND_NAME=umax_pp -D_REENTRANT -DPATH_SANE_CONFIG_DIR=/etc/sane.d 	  -DPATH_SANE_DATA_DIR=/usr/share 	  -DPATH_SANE_LOCK_DIR=/var/lock/sane 	  -DV_MAJOR=1 -DV_MINOR=0  -g -O2 -W -Wall -MT libumax_pp_la-umax_pp_low.lo -MD -MP -MF .deps/libumax_pp_la-umax_pp_low.Tpo -c -o libumax_pp_la-umax_pp_low.lo `test -f 'umax_pp_low.c' || echo './'`umax_pp_low.c
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:43:2: error: #error "This header must not be used in combination with <sys/io.h>."
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:184:1: error: conflicting types for 'inb'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:47:1: note: previous definition of 'inb' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:193:1: error: conflicting types for 'inl'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:83:1: note: previous definition of 'inl' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:202:1: error: conflicting types for 'insb'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:140:1: note: previous definition of 'insb' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:211:1: error: conflicting types for 'insw'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:147:1: note: previous definition of 'insw' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:220:1: error: conflicting types for 'insl'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:154:1: note: previous definition of 'insl' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:235:1: error: conflicting types for 'inw'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:65:1: note: previous definition of 'inw' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:244:1: error: conflicting types for 'outb'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:100:1: note: previous definition of 'outb' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:250:1: error: conflicting types for 'outl'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:127:1: note: previous definition of 'outl' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:256:1: error: conflicting types for 'outsb'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:161:1: note: previous definition of 'outsb' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:264:1: error: conflicting types for 'outsw'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:168:1: note: previous definition of 'outsw' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:272:1: error: conflicting types for 'outsl'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:175:1: note: previous definition of 'outsl' was here
In file included from /usr/include/machine/cpufunc.h:8:0,
                 from umax_pp_low.c:76:
/usr/include/machine-amd64/cpufunc.h:280:1: error: conflicting types for 'outw'
In file included from umax_pp_low.c:59:0:
/usr/include/x86_64-kfreebsd-gnu/sys/io.h:113:1: note: previous definition of 'outw' was here
umax_pp_low.c: In function 'sanei_ioperm':
umax_pp_low.c:409:42: warning: parameter 'enable' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c: In function 'sanei_inb':
umax_pp_low.c:419:25: warning: parameter 'port' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c: In function 'sanei_outb':
umax_pp_low.c:427:26: warning: parameter 'port' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c:427:46: warning: parameter 'value' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c: In function 'sanei_insb':
umax_pp_low.c:435:26: warning: parameter 'port' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c:435:67: warning: parameter 'count' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c: In function 'sanei_insl':
umax_pp_low.c:446:26: warning: parameter 'port' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c:446:67: warning: parameter 'count' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c: In function 'sanei_outsb':
umax_pp_low.c:457:27: warning: parameter 'port' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c:458:21: warning: parameter 'count' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c: In function 'sanei_outsl':
umax_pp_low.c:469:27: warning: parameter 'port' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c:470:21: warning: parameter 'count' set but not used [-Wunused-but-set-parameter]
umax_pp_low.c: In function 'sanei_umax_pp_initPort':
umax_pp_low.c:955:20: warning: unused variable 'rc' [-Wunused-variable]
umax_pp_low.c:955:13: warning: unused variable 'modes' [-Wunused-variable]
umax_pp_low.c:955:7: warning: unused variable 'mode' [-Wunused-variable]
umax_pp_low.c:953:18: warning: variable 'ecp' set but not used [-Wunused-but-set-variable]
umax_pp_low.c:953:7: warning: variable 'found' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'sendCommand':
umax_pp_low.c:2129:7: warning: variable 'gbufferRead' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'ECPconnect':
umax_pp_low.c:2724:21: warning: variable 'data' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'EPPregisterRead':
umax_pp_low.c:2892:7: warning: variable 'value' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'ECPregisterWrite':
umax_pp_low.c:2974:17: warning: variable 'breg' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'ECPSetBuffer':
umax_pp_low.c:3227:17: warning: variable 'breg' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'ECPbufferRead':
umax_pp_low.c:3310:7: warning: variable 'breg' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'EPPconnect':
umax_pp_low.c:4069:7: warning: variable 'data' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'EPPcmdGetBuffer610p':
umax_pp_low.c:8652:13: warning: variable 'wait' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'cmdGetBuffer':
umax_pp_low.c:8971:17: warning: variable 'i' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'cmdGetBuffer32':
umax_pp_low.c:9111:17: warning: variable 'i' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'cmdGetBlockBuffer':
umax_pp_low.c:9258:12: warning: variable 'i' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'sanei_umax_pp_startScan':
umax_pp_low.c:10978:8: warning: variable 'dest' set but not used [-Wunused-but-set-variable]
umax_pp_low.c: In function 'offsetCalibration1220p':
umax_pp_low.c:11939:7: warning: variable 'opsc10' set but not used [-Wunused-but-set-variable]
make[3]: *** [libumax_pp_la-umax_pp_low.lo] Error 1
make[3]: Leaving directory `/build/buildd-sane-backends_1.0.22-7.2-kfreebsd-amd64-GIP5Vu/sane-backends-1.0.22/backend'
make[2]: *** [all] Error 2
make[2]: Leaving directory `/build/buildd-sane-backends_1.0.22-7.2-kfreebsd-amd64-GIP5Vu/sane-backends-1.0.22/backend'
make[1]: *** [all-recursive] Error 1
make[1]: Leaving directory `/build/buildd-sane-backends_1.0.22-7.2-kfreebsd-amd64-GIP5Vu/sane-backends-1.0.22'
make: *** [build-stamp] Error 2
dpkg-buildpackage: error: debian/rules build gave error exit status 2

Full build log at
https://buildd.debian.org/status/fetch.php?pkg=sane-backends&arch=kfreebsd-amd64&ver=1.0.22-7.2&stamp=1341355945

Regards

    Christoph

If you have further questions please mail debian-bsd@lists.debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Julien BLACHE <jblache@debian.org>:
Bug#680234; Package src:sane-backends. (Tue, 10 Jul 2012 18:30:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Petr Salinger <Petr.Salinger@seznam.cz>:
Extra info received and forwarded to list. Copy sent to Julien BLACHE <jblache@debian.org>. (Tue, 10 Jul 2012 18:30:04 GMT) Full text and rfc822 format available.

Message #10 received at 680234@bugs.debian.org (full text, mbox):

From: Petr Salinger <Petr.Salinger@seznam.cz>
To: 680234@bugs.debian.org
Cc: control@bugs.debian.org
Subject: sane-backends: FTBFS[kfreebsd]:
Date: Tue, 10 Jul 2012 20:45:56 +0200 (CEST)
tags 680234 +patch
--

Hi,

please use tweak bellow.

Petr


--- backend/umax_pp_low.c~      2010-12-02 00:49:58.000000000 +0100
+++ backend/umax_pp_low.c       2012-07-10 20:20:16.000000000 +0200
@@ -73,8 +73,10 @@
 #endif

 #ifdef HAVE_MACHINE_CPUFUNC_H
+#ifndef __GLIBC__
 #include <machine/cpufunc.h>
 #endif
+#endif

 #ifdef HAVE_I386_SET_IOPERM
 #include <machine/sysarch.h>





Added tag(s) patch. Request was from Petr Salinger <Petr.Salinger@seznam.cz> to control@bugs.debian.org. (Tue, 10 Jul 2012 18:30:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Julien BLACHE <jblache@debian.org>:
Bug#680234; Package src:sane-backends. (Sun, 15 Jul 2012 21:30:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Gilbert <mgilbert@debian.org>:
Extra info received and forwarded to list. Copy sent to Julien BLACHE <jblache@debian.org>. (Sun, 15 Jul 2012 21:30:04 GMT) Full text and rfc822 format available.

Message #17 received at 680234@bugs.debian.org (full text, mbox):

From: Michael Gilbert <mgilbert@debian.org>
To: 680234@bugs.debian.org
Subject: re: sane-backends: FTBFS[kfreebsd]
Date: Sun, 15 Jul 2012 17:27:36 -0400
[Message part 1 (text/plain, inline)]
Hi, I've uploaded an nmu fixing this issue, based on the above patch.
See attached for nmu debdiff.

Best wishes,
Mike
[sane-backends.patch (application/octet-stream, attachment)]

Reply sent to Michael Gilbert <mgilbert@debian.org>:
You have taken responsibility. (Sun, 15 Jul 2012 21:45:14 GMT) Full text and rfc822 format available.

Notification sent to debian-bsd@lists.debian.org:
Bug acknowledged by developer. (Sun, 15 Jul 2012 21:45:14 GMT) Full text and rfc822 format available.

Message #22 received at 680234-close@bugs.debian.org (full text, mbox):

From: Michael Gilbert <mgilbert@debian.org>
To: 680234-close@bugs.debian.org
Subject: Bug#680234: fixed in sane-backends 1.0.22-7.3
Date: Sun, 15 Jul 2012 21:32:29 +0000
Source: sane-backends
Source-Version: 1.0.22-7.3

We believe that the bug you reported is fixed in the latest version of
sane-backends, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 680234@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Michael Gilbert <mgilbert@debian.org> (supplier of updated sane-backends package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Sun, 15 Jul 2012 17:07:15 -0400
Source: sane-backends
Binary: sane-utils libsane-common libsane libsane-dev libsane-dbg
Architecture: source amd64
Version: 1.0.22-7.3
Distribution: unstable
Urgency: low
Maintainer: Julien BLACHE <jblache@debian.org>
Changed-By: Michael Gilbert <mgilbert@debian.org>
Description: 
 libsane    - API library for scanners
 libsane-common - API library for scanners -- documentation and support files
 libsane-dbg - API development library for scanners [debug symbols]
 libsane-dev - API development library for scanners [development files]
 sane-utils - API library for scanners -- utilities
Closes: 680234
Changes: 
 sane-backends (1.0.22-7.3) unstable; urgency=low
 .
   * Non-maintainer upload.
   * Fix build failure on kfreebsd (closes: #680234).
Checksums-Sha1: 
 ece62dd4d014fa2a08ae95408f2fc8a46cda8751 2965 sane-backends_1.0.22-7.3.dsc
 f440cdd5c5207406cc9d2cd38fef0a2ddda3060d 65687 sane-backends_1.0.22-7.3.debian.tar.gz
 3545b44f073f4db1df33d024454d018722b215ff 236972 sane-utils_1.0.22-7.3_amd64.deb
 f2fdf2b0ceba995cf8b20610ac3e7ba88e39911e 1015648 libsane-common_1.0.22-7.3_amd64.deb
 df7020ec99c7748ea7d6bce33f38753e2a69f66c 3679450 libsane_1.0.22-7.3_amd64.deb
 18d167368eda0ed9d84197d97d62aa8b9e2878c6 4435284 libsane-dev_1.0.22-7.3_amd64.deb
 ed06251eed1e3d402acbe0fccf910d22fbaa307b 6618480 libsane-dbg_1.0.22-7.3_amd64.deb
Checksums-Sha256: 
 f73b081cfdd9390fbcbd90e207e8e54e499e1f8a7cd863cfd33485dd738c3da9 2965 sane-backends_1.0.22-7.3.dsc
 256f0dc050072349b48ccdae79ac0352e0a3d8d8e57bb736f1e8986f87adf521 65687 sane-backends_1.0.22-7.3.debian.tar.gz
 ddc039762290a7d0df34fa197f26cb0420bdc7969ad6e6ab5041f5821a868c35 236972 sane-utils_1.0.22-7.3_amd64.deb
 5a14b6d5d30fdbfd78c5d3114ddada6bb6a558a735271b27ec5b845481126a7b 1015648 libsane-common_1.0.22-7.3_amd64.deb
 ea3bb4e25143f4c8c9419564eb744ec778f34e2a08c6cfd07b70ae3a4bfaa5e5 3679450 libsane_1.0.22-7.3_amd64.deb
 8e5d6b9e5100055cb7db78b756680e15a69281e45870d589287554c4e225df04 4435284 libsane-dev_1.0.22-7.3_amd64.deb
 a51fd9a20fa990b0f1b8683461b8b793bb779bdc51d913c33628d6c3b67030df 6618480 libsane-dbg_1.0.22-7.3_amd64.deb
Files: 
 fcd60fb5fa5f8cc16313436b651b2c89 2965 graphics optional sane-backends_1.0.22-7.3.dsc
 5bdb9b07f9ce8e10c1e57d6cc35f857c 65687 graphics optional sane-backends_1.0.22-7.3.debian.tar.gz
 91c7f255b6e44502421b0f2cf5ccac2f 236972 graphics optional sane-utils_1.0.22-7.3_amd64.deb
 dabf15300473dc39aa197ad8ac929555 1015648 libs optional libsane-common_1.0.22-7.3_amd64.deb
 623f2e31072483f3a5a96006f6c7d16f 3679450 libs optional libsane_1.0.22-7.3_amd64.deb
 1bdd5de139eb0f018665ee18b782a356 4435284 libdevel optional libsane-dev_1.0.22-7.3_amd64.deb
 b77089ce2d5821080fdd7c07a520a658 6618480 debug extra libsane-dbg_1.0.22-7.3_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQQcBAEBCAAGBQJQAzTZAAoJELjWss0C1vRzkx4f/3fQMjN96utx+0E7IQbyYL2R
7fTkUOL/BM6Dx/lisEwAPQc4FG567MWXKW4x6riSlWBd33BLjwayUZhhyhsbkb3T
9HdyTb8Ya6jL+K661zdPNTpgrzUZKD/vGqBbXNfkCCwYj+Vf7dMBt7wBW1dryLdm
8OVAiLiTZonjp87HeoEdd243GnWbi8iIIbp8pwSFm+w/60MuAfLztN+ObNGmGuBi
Y43W9SB2Q6VCiBWFRhfUs2HyCC4yEXKUXyX5/JRSz7H6LH2bJYuofDYrGfk7NawC
OAPM9j+CHMi8cDWsdhpw64bm4Qi/phkOszP0BhU9kCY23Ov6qgxJ5fT+9qojcrcp
XPPmrfUWGwGzLqDB9WR+nbcr8aW26xECl36T2rlReLs14wmdHW74v3uEt9hJjlFk
xY1QHmaK83mqfn5ml5AB4VXYd9rxlulFD6aT7c5/2dGFcCTdRrlJuSzsn+fr1lrW
dUWBYhf3SMaF2vBBEM7iYOC7C3zHXqsTYgIK7Vmn+wydVsyHvq/D5PiZQ3kJ3XPA
5Ht8HWTR70zvq74RbCQkcOXYra5JMBmd4S7AjeM4b7/n7KbxJkCUzSIwBnE+hbA7
6lozavcHu5ohrdf4WCXfGN9BXbA3qaxWmHorHt71FJwf5XRsA0LkRkzq4Q+IzCMn
QVzQPo2fKor/SAcvxPOvCDYvVnQx7vjZRAbL9HBZFW0YpLNX99kKW+TJ/o7WcxaM
krUFeJu3LzIapy0vIHKT1k+mJLkEiCwMN4ztqinSB4EvfmsXd8XiHjL5GalK+IvR
DLDyT83S878qRktgML4P3F3gBPA2R8dkea8VtpEpIIFcFV+19UGuPOr5IBx1qJjE
On1YSsgino6QYgxWSDnuuZGYBnSa4Ot/MuVsHAClr5ILUAb4Jioc0PjdDjnCU6PB
6/cnDpe/0B6axRaSNllKcO/UhkRWBbB+ribjiQNlez3DFXcnjAkRUVVUW6sEMSV4
gKUK4onQ2G0Zu8HJHqtidbgAwqHkJFdSExLB42+ZOm+OGqcxOxUVUGPFAkXxJhOz
TnBjItfSzZtgqXsqNpg/0VoTiexvS7zs+yWUxJ8mAk/IydWveDByEmvIkTbnAwla
JMRsRdMR9qV6ETplRfhPgLz5epVhUbE0dcH6z/xVfVeKFn1DKQGuHVC5w6MChL+k
2qBhDewDxe2o1/cmsvCT4WD2gUqDKd12lkasn7AeroH6PzTCmQDsLefqC9Hicx0r
BeTbIG1CuVmT9lFslPJ6UBiQ0xYnG3Kn41HkiJLIoWpQcRmL00yXEBWXiTcuGCTL
7EQdrFv165+G2cHtJhOZ73hL2Ujg6l5xevhN1IFvfZSlzP5xB6rU6A1asO+Db9I=
=sTYy
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 23 Aug 2012 07:27:33 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 06:13:26 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.